
#include <util/delay.h>
#include <avr/io.h>

#include "./apps.h"
#include "../types/ranged.h"
#include "../types/mytypes.h"
#include "../menu/displayroutines.h"
#include "../menu/menu.h"
#include "./realtimeclock.h"

t_datetime DateTimeToChange;


void SetDateTimeToChange(const t_datetime datetime){
    DateTimeToChange = datetime;
}


void SetTimeApp(uint8_t Event){
    static t_ranged_uint8_t SetPosition = {
            .value = 0,
            .top = 5,
            .bottom = 0,
    };

    switch( Event){
     case OK:
        SetPosition.value = 0;
        RealTime_SetDateTime(&DateTimeToChange);
        ActiveApplication = &MenuApplication;
        ExitItem();
        return;
     case UP:
        switch(SetPosition.value){
            case 0:{
                RealTime_IncrementHour(&DateTimeToChange);
            break;
            }
            case 1:{
                RealTime_IncrementMinute(&DateTimeToChange);
            break;
            }
            case 2:{
                RealTime_IncrementSecond(&DateTimeToChange);
            break;
            }
            case 3:{
                RealTime_IncrementDay(&DateTimeToChange);
            break;
            }
            case 4:{
                RealTime_IncrementMonth(&DateTimeToChange);
            break;
            }
            case 5:{
                RealTime_IncrementYear(&DateTimeToChange);
            break;
            }
        }
        break;
     case DOWN:
        switch(SetPosition.value){
            case 0:{
                RealTime_DecrementHour(&DateTimeToChange);
            break;
            }
            case 1:{
                RealTime_DecrementMinute(&DateTimeToChange);
            break;
            }
            case 2:{
                RealTime_DecrementSecond(&DateTimeToChange);
            break;
            }
            case 3:{
                RealTime_DecrementDay(&DateTimeToChange);
            break;
            }
            case 4:{
                RealTime_DecrementMonth(&DateTimeToChange);
            break;
            }
            case 5:{
                RealTime_DecrementYear(&DateTimeToChange);
            break;
            }
        }
        break;
     case LEFT:
        rangedDec_uint8_t(&SetPosition);
        break;
     case RIGHT:
        rangedInc_uint8_t(&SetPosition);
        break;
     case NO_KEY:
        break;
    }
    DisplayTimeAt(1, 1, &DateTimeToChange);
    DisplayDateAt(1, 3, &DateTimeToChange, 0);
    //Zeit
    PrintStringPos(1, 2, "        ");
    //Datum
    PrintStringPos(1, 4, "          ");

    char *HighlightChar = "^^";
    uint8_t Highlightx = 0;
    uint8_t Highlighty = 2;
    if (SetPosition.value == 5){
        HighlightChar = "^^^^";
    }

    switch(SetPosition.value){
        case 0:
        case 3:{
            /*                    19:52:46*/
            Highlightx = 0 + 1;
        break;
        }
        case 1:
        case 4:{
            /*                    19:52:46*/
            Highlightx = 3 + 1;
        break;
        }
        case 2:
        case 5:{
            /*                    19:52:46*/
            Highlightx = 6 + 1;
        break;
        }
    }
    if(SetPosition.value > 2){
        Highlighty = 4;
    }
    PrintStringPos  (Highlightx, Highlighty, HighlightChar);
}
